#include <stdio.h>
#include <assert.h>
#include <math.h>
#include "odicon.h"

static double (*dfunc)(int,double*);
static double ifunc(int dim, int x[]) { return int_func(dim, dfunc, x); }

double mgconv_minimize_relax(int dim, double func(int dim, double x[]),
			     int init[]) {
    lbfgs_call_int(dim, func, init);
    dfunc = func;
    return mgconv_minimize2(dim, ifunc, init);
}


static double (*mfunc)(int,double*);
static int stored_sum;
static double mgfunc(int dim, double* x) {
    int i;
    double y[1000];
    double sum = stored_sum;
    
    for (i=0; i<dim; i++) {
        y[i] = x[i];
        sum -= x[i];
    }
    y[i] = sum;
    return mfunc(dim+1, y);
}

double mconv_minimize_relax(int dim, double func(int dim, double x[]),
                            int init[]) {
    int i, sum = 0, y[1000];

    mfunc = func;
    stored_sum = 0;
    for (i=0; i<dim; i++) {
        y[i] = init[i];
        stored_sum += init[i];
    }

    lbfgs_call_int(dim-1, mgfunc, y);

    sum = stored_sum;
    for (i=0; i<dim-1; i++) {
        init[i] = y[i];
        sum -= y[i];
    }
    init[i] = sum;

    dfunc = func;
    return mconv_minimize2(dim, ifunc, init);
}
